doctype html
html(lang="en")
  head
    meta(charset="UTF-8")
    meta(http-equiv="X-UA-Compatible", content="IE=edge")
    meta(name="viewport", content="width=device-width, initial-scale=1.0")

    title Checkout

    link(href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet")

    script(src="https://cdn.jsdelivr.net/gh/alpinejs/alpine@v2.7.0/dist/alpine.min.js" defer)
    script(
      src="https://cdnjs.cloudflare.com/ajax/libs/cleave.js/1.6.0/cleave.min.js"
      integrity="sha512-KaIyHb30iXTXfGyI9cyKFUIRSSuekJt6/vqXtyQKhQP6ozZEGY8nOtRS6fExqE4+RbYHus2yGyYg1BrqxzV6YA=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer")
    script(src="./assets/js/faker.min.js")

    //- SrPago dependency libraries
    script(type="text/javascript" src="https://js.srpago.com/v1/konfiopagos.v2.min.js")
    script(type="text/javascript" src="https://js.srpago.com/v1/srpago.encryption.min.js")

    style(media="screen").
      .disabled\:opacity-50:disabled {
        cursor: wait;
        opacity: .5;
      }
  body
    div(x-data="frmCheckout()" x-init="init()")
      div(class="bg-gray-300 text-gray-500 min-h-screen" x-cloak)
        div(class="py-6")
          div(class="max-w-md mx-auto bg-white shadow-lg rounded-lg md:max-w-xl mx-2")
            div(class="md:flex")
              div(class="w-full p-4 px-5 py-5")
                div(class="flex justify-center text-green-400")
                  h2(class="text-3xl font-semibold uppercase")
                    span(x-show="step('checkout')" x-transition) Checkout
                    span(x-show="step('completed')" x-transition) Completed

                //- Step: Checkout
                div(x-show="step('checkout')" x-transition)

                  //- Order Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Order information

                    div(class="mt-2")
                      label(for="checkout_description" class="block text-sm font-semibold") Description
                      input(
                        type="text"
                        id="checkout_description"
                        x-model="data.checkout.description"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="grid md:grid-cols-3 md:gap-2")
                      div(class="mt-2")
                        label(for="checkout_reference" class="block text-sm font-semibold") Reference
                        input(
                          type="text"
                          id="checkout_reference"
                          x-model="data.checkout.reference"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                      div(class="mt-2")
                        label(for="checkout_amount" class="block text-sm font-semibold") Amount
                        input(
                          type="text"
                          id="checkout_amount"
                          x-model="data.checkout.amount"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                      div(class="mt-2")
                        label(for="checkout_currency" class="block text-sm font-semibold") Currency
                        select(
                          id="checkout_currency"
                          x-model="data.checkout.currency"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm bg-white"
                        )
                          template(x-for="currency in catalogs.currencies" :key="currency")
                            option(:value="currency" x-text="currency")

                  //- Customer Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Customer information

                    div(class="mt-2")
                      label(for="checkout_customer_name" class="block text-sm font-semibold") Name
                      input(
                        type="text"
                        id="checkout_customer_name"
                        x-model="data.checkout.customer.name"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="mt-2")
                      label(for="checkout_customer_email" class="block text-sm font-semibold") Email
                      div(class="relative")
                        input(
                          type="email"
                          id="checkout_customer_email"
                          x-model="data.checkout.customer.email"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                  //- Card Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Card information

                    div(class="mt-2")
                      label(for="card_owner" class="block text-sm font-semibold") Owner
                      input(
                        type="text"
                        id="card_owner"
                        x-model="data.card.owner"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="mt-2")
                      label(for="card_number" class="block text-sm font-semibold") Number
                      div(class="relative")
                        input(
                          type="text"
                          id="card_number"
                          x-model="data.card.number"
                          class="input-card-number border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="0000 0000 0000 0000"
                        )

                    div(class="grid md:grid-cols-2 md:gap-2")
                      div(class="mt-2")
                        label(for="card_expiry" class="block text-sm font-semibold") Expiry
                        input(
                          type="text"
                          id="card_expiry"
                          class="input-card-expiry border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="MM/YY"
                          :value="`${data.card.expiry_month}/${data.card.expiry_year}`"
                        )

                      div(class="mt-2")
                        label(for="card_cvv" class="block text-sm font-semibold") CVV
                        input(
                          type="password"
                          id="card_cvv"
                          x-model="data.card.cvv"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="***"
                          maxlength="4"
                        )

                  //- Error Messages
                  div(
                    x-show="data.error.message"
                    class="mt-6 py-3 pl-4 pr-10 leading-normal text-red-800 bg-red-50 border-t-4 border-red-400"
                  )
                    div(class="font-bold" x-text="data.error.message")

                  div(class="flex justify-end mt-6")
                    button(
                      type="button"
                      class="disabled:opacity-50 h-10 w-48 rounded font-bold text-xl bg-blue-500 hover:bg-blue-400 text-white tracking-widest"
                      x-bind:disabled="data.working"
                      @click="handleSubmit()"
                    )
                      span(x-show="!data.working") PAY |
                        span(x-text="` $${data.checkout.amount}`")
                      span(x-show="data.working" class="text-base") PROCESSING ...

                //- Step: Completed
                div(x-show="step('completed')" x-transition)

                  div(class="mt-2 text-center")
                    p The payment has been completed
                    p(class="text-gray-400 text-center text-xs font-semibold")
                      a(x-bind:href="data.receipt_url" target="_blank" class="font-normal") Receipt of payment

                  svg(width='513' height='513' class="w-24 h-24 mx-auto my-8" viewBox='0 0 513 513' fill='none' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink')
                    rect(x='0.150574' width='512' height='512' fill='url(#pattern0)')
                    path(fill-rule='evenodd' clip-rule='evenodd' d='M228.651 1.176C215.826 2.467 196.76 6.435 181.594 10.97C122.404 28.667 70.3716 68.943 37.6456 122.396C4.29956 176.861 -7.56244 242.703 4.74656 305C17.1746 367.901 51.4906 422.503 102.902 461.182C186.073 523.755 300.553 529.119 389.58 474.613C429.869 449.946 461.824 415.68 483.63 373.761C524.83 294.558 521.41 198.76 474.656 122.396C441.93 68.943 389.898 28.667 330.708 10.97C314.828 6.222 296.364 2.487 281.727 1.063C268.959 -0.18 241.532 -0.121 228.651 1.176ZM386.151 129.655C390.497 131.582 394.834 135.303 406.826 147.394C421.752 162.445 422.037 162.813 424.195 169.92C426.803 178.504 426.37 184.822 422.649 192.5C420.72 196.482 401.437 216.258 327.939 289.635C264.064 353.404 234.266 382.49 231.151 384.108C227.551 385.978 225.051 386.451 218.651 386.473C204.447 386.521 206.505 388.203 145.554 326.709C85.1756 265.792 86.6666 267.633 86.6596 254C86.6536 242.863 88.8036 239.316 106.126 221.88C124.077 203.812 126.302 202.507 139.151 202.503C146.463 202.501 149.457 202.925 152.151 204.347C154.076 205.363 169.709 220.206 186.892 237.332L218.133 268.47L286.392 200.343C333.993 152.835 355.989 131.546 359.071 130.001C367.695 125.679 376.916 125.561 386.151 129.655Z' fill='#32BA7C')
                    path(fill-rule='evenodd' clip-rule='evenodd' d='M425.313 171.034C427.006 175.891 425.849 187.751 423.171 193C421.544 196.188 393.872 224.439 328.263 289.89C225.784 392.124 231.376 387.176 218.297 387.176C214.335 387.176 209.914 386.51 207.677 385.575C205.569 384.694 203.706 384.112 203.538 384.28C203.369 384.449 229.95 411.302 262.605 443.954L321.979 503.322L332.315 500.049C373.55 486.993 406.015 467.247 436.706 436.555C483.983 389.276 509.219 331.258 511.746 264.036L512.33 248.5L472.654 212C450.833 191.925 431.008 173.791 428.6 171.703L424.222 167.905L425.313 171.034Z' fill='#0AA06E')
                    defs
                      pattern#pattern0(patternContentUnits='objectBoundingBox' width='1' height='1')
                        use(xlink:href='#image0_1_9' transform='scale(0.00195312)')


          div(class="w-full mt-1 text-center text-xs text-gray-400")
            span(class="pr-2") Powered by #[strong SrPago]
            span -
            span(class="pl-2" x-text="`v${version}`")

    script.
      const C = {
        ENDPOINT_CHECKOUT_PAYMENT: `#{app_host}/api/checkout/payment`,

        SRPAGO_LIVEMODE: #{srpago_livemode},
        SRPAGO_APIKEY: '#{srpago_apikey}',
      };

      SrPago.setLiveMode(C.SRPAGO_LIVEMODE);
      SrPago.setPublishableKey(C.SRPAGO_APIKEY);

      function frmCheckout() {
        return {
          version: '0.1.0',

          data: {
            // This structure is sent to the server to make the payment request.
            checkout: {
              reference: null,
              description: null,
              amount: 0,
              currency: 'MXN',

              customer: {
                name: null,
                email: null,
              },

              card: {
                token: null,
              },
            },

            // This structure is used to tokenize the card.
            // For security reasons, this information should never be sent to the merchant server.
            card: {
              owner: null,
              number: null,
              expiry_month: null,
              expiry_year: null,
              cvv: null,
            },

            receipt_url: '',

            step: 'checkout', // checkout | completed
            working: false,

            error: {
              message: '',
            },
          },

          catalogs: {
            currencies: [
              'MXN',
            ],
          },

          async init() {
            const randomInt = function (min, max) {
              return Math.floor(Math.random() * (max - min)) + min;
            };

            const customerFirstname = faker.name.firstName();
            const customerLastname = faker.name.lastName();
            const date = new Date();

            this.data.checkout.reference = `ref_${faker.git.shortSha()}`;
            this.data.checkout.description = faker.commerce.productName();
            this.data.checkout.amount = faker.finance.amount();
            this.data.checkout.customer.name = `${customerFirstname} ${customerLastname}`;
            this.data.checkout.customer.email = faker.internet.exampleEmail(customerFirstname, customerLastname).toLowerCase();
            this.data.card.owner = faker.fake("{{name.firstName}} {{name.lastName}}");
            this.data.card.number = faker.helpers.replaceCreditCardSymbols('5204 #### #### ###L', '#');
            this.data.card.expiry_month = ('0' + date.getMonth()).slice(-2);
            this.data.card.expiry_year = date.getFullYear() + randomInt(2, 10);
            this.data.card.cvv = faker.finance.creditCardCVV();


            new Cleave('.input-card-number', {
              creditCard: true,
            });

            new Cleave('.input-card-expiry', {
              date: true,
              datePattern: ['m', 'y'],
              onValueChanged: e => {
                const expiry = e.target.value.split('/');

                this.data.expiry_month = expiry[0] || '';
                this.data.expiry_year = expiry[1] || '';
              }
            });
          },

          step(step) {
            return step == this.data.step;
          },

          toStep(step) {
            return this.data.step = step;
          },

          async handleSubmit() {
            this.data.working = true;
            this.data.error.message = '';

            // Callback that is executed if tokenization was successful.
            const successResponseHandler = response => {
              this.data.checkout.card.token = response.token;

              // Payment request is sent.
              fetch(`${C.ENDPOINT_CHECKOUT_PAYMENT}`, {
                headers: {
                  'Content-Type': 'application/json',
                },
                redirect: 'follow',
                method: 'POST',
                body: JSON.stringify(this.data.checkout),
              })
                .then(response => response.json())
                .then(response => {
                  this.data.receipt_url = response.recipe.url;

                  this.toStep('completed');
                })
                .catch(error => {
                  this.data.error.message = `ERROR: ${error.message}`;
                })
                .finally(() => { this.data.working = false; });
            };

            // Callback that is executed if a tokenization error has occurred.
            const errorResponseHandler = error => {
              this.data.error.message = `ERROR: (${error.code}) ${error.message}`;

              this.data.working = false;
            };

            const tokenizationPayload = {
              number: this.data.card.number.replace(/\s/g, ''),
              holder_name: ReplaceAccents(this.data.card.owner),
              cvv: this.data.card.cvv,
              exp_month: this.data.card.expiry_month,
              exp_year: this.data.card.expiry_year,
            };

            SrPago.token.create(tokenizationPayload, successResponseHandler, errorResponseHandler);
          },
        }
      };

      function ReplaceAccents(text) {
        const accentsMap = {
          a: 'á|à|ã|â|À|Á|Ã|Â',
          e: 'é|è|ê|É|È|Ê',
          i: 'í|ì|î|Í|Ì|Î',
          o: 'ó|ò|ô|õ|Ó|Ò|Ô|Õ',
          u: 'ú|ù|û|ü|Ú|Ù|Û|Ü',
          c: 'ç|Ç',
          n: 'ñ|Ñ',
        };

        return Object.keys(accentsMap).reduce(
          (acc, cur) => acc.replace(new RegExp(accentsMap[cur], 'g'), cur),
          text
        );
      }
